

require "import"
import "android.content.Context"
import "android.os.Vibrator"
import "android.media.ToneGenerator"
import "android.media.AudioManager"
import "android.widget.*"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"
import "android.text.Html"
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(40)

local translationResult = ""
local languageCodes = {
  ["Английский"] = "en",
  ["Азербайджанский"] = "az",
  ["Аймара"] = "ay",
  ["Албанский"] = "sq",
  ["Амхарский"] = "am",
  ["Арабский"] = "ar",
  ["Армянский"] = "hy",
  ["Ассамский"] = "as",
  ["Африкаанс"] = "af",
  ["Бамбара"] = "bm",
  ["Баскский"] = "eu",
  ["Белорусский"] = "be",
  ["Бенгальский"] = "bn",
  ["Бирманский"] = "my",
  ["Болгарский"] = "bg",
  ["Боснийский"] = "bs",
  ["Бходжпури"] = "bhj",
  ["Валлийский"] = "cy",
  ["Венгерский"] = "hu",
  ["Вьетнамский"] = "vi",
  ["Гавайский"] = "haw",
  ["Галисийский"] = "gl",
  ["Греческий"] = "el",
  ["Грузинский"] = "ka",
  ["Гуарани"] = "gn",
  ["Гуджарати"] = "gu",
  ["Датский"] = "da",
  ["Догри"] = "dog",
  ["Зулу"] = "zu",
  ["Иврит"] = "he",
  ["Игбо"] = "ig",
  ["Идиш"] = "yi",
  ["Илоканский"] = "ilo",
  ["Индонезийский"] = "id",
  ["Ирландский"] = "ga",
  ["Исландский"] = "is",
  ["Испанский"] = "es",
  ["Итальянский"] = "it",
  ["Йоруба"] = "yo",
  ["Казахский"] = "kk",
  ["Каннада"] = "kn",
  ["Каталанский"] = "ca",
  ["Кечуа"] = "qu",
  ["Киргизский"] = "ky",
  ["Китайский (традиционный)"] = "zh-TW",
  ["Китайский (упрощенный)"] = "zh-CN",
  ["Конкани"] = "kok",
  ["Корейский"] = "ko",
  ["Корсиканский"] = "co",
  ["Коса"] = "xh",
  ["Креольский (гаити)"] = "ht",
  ["Крио"] = "kri",
  ["Курдский (курманджи)"] = "ku",
  ["Курдский (сорани)"] = "ckb",
  ["Кхмерский"] = "km",
  ["Лаосский"] = "lo",
  ["Латинский"] = "la",
  ["Латышский"] = "lv",
  ["Лингала"] = "ln",
  ["Литовский"] = "lt",
  ["Луганда"] = "lg",
  ["Люксембургский"] = "lb",
  ["Майтхили"] = "mai",
  ["Македонский"] = "mk",
  ["Малагасийский"] = "mg",
  ["Малайский"] = "ms",
  ["Малаялам"] = "ml",
  ["Мальдивский"] = "dv",
  ["Мальтийский"] = "mt",
  ["Маори"] = "mi",
  ["Маратхи"] = "mr",
  ["Мейтейлон (манипури)"] = "mni",
  ["Мизо"] = "lus",
  ["Монгольский"] = "mn",
  ["Немецкий"] = "de",
  ["Непальский"] = "ne",
  ["Нидерландский"] = "nl",
  ["Норвежский"] = "no",
  ["Ория"] = "or",
  ["Оромо"] = "om",
  ["Панджаби"] = "pa",
  ["Персидский"] = "fa",
  ["Польский"] = "pl",
  ["Португальский"] = "pt",
  ["Пушту"] = "ps",
  ["Руанда"] = "rw",
  ["Румынский"] = "ro",
  ["Русский"] = "ru",
  ["Самоанский"] = "sm",
  ["Санскрит"] = "sa",
  ["Себуанский"] = "ceb",
  ["Сепеди"] = "nso",
  ["Сербский"] = "sr",
  ["Сесото"] = "st",
  ["Сингальский"] = "si",
  ["Синдхи"] = "sd",
  ["Словацкий"] = "sk",
  ["Словенский"] = "sl",
  ["Сомалийский"] = "so",
  ["Суахили"] = "sw",
  ["Сунданский"] = "su",
  ["Таджикский"] = "tg",
  ["Тайский"] = "th",
  ["Тамильский"] = "ta",
  ["Татарский"] = "tt",
  ["Телугу"] = "te",
  ["Тигринья"] = "ti",
  ["Тсонга"] = "ts",
  ["Турецкий"] = "tr",
  ["Туркменский"] = "tk",
  ["Узбекский"] = "uz",
  ["Уйгурский"] = "ug",
  ["Украинский"] = "uk",
  ["Урду"] = "ur",
  ["Филиппинский"] = "fil",
  ["Финский"] = "fi",
  ["Французский"] = "fr",
  ["Фризский"] = "fy",
  ["Хауса"] = "ha",
  ["Хинди"] = "hi",
  ["Хмонг"] = "hmn",
  ["Хорватский"] = "hr",
  ["Чви"] = "ny",
  ["Чева"] = "ny",
  ["Чешский"] = "cs",
  ["Шведский"] = "sv",
  ["Шона"] = "sn",
  ["Шотландский (гэльский)"] = "gd",
  ["Эве"] = "ee",
  ["Эсперанто"] = "eo",
  ["Эстонский"] = "et",
  ["Яванский"] = "jv",
  ["Японский"] = "ja",
}
local items = {
  "Английский",
  "Азербайджанский",
  "Аймара",
  "Албанский",
  "Амхарский",
  "Арабский",
  "Армянский",
  "Ассамский",
  "Африкаанс",
  "Бамбара",
  "Баскский",
  "Белорусский",
  "Бенгальский",
  "Бирманский",
  "Болгарский",
  "Боснийский",
  "Бходжпури",
  "Валлийский",
  "Венгерский",
  "Вьетнамский",
  "Гавайский",
  "Галисийский",
  "Греческий",
  "Грузинский",
  "Гуарани",
  "Гуджарати",
  "Датский",
  "Догри",
  "Зулу",
  "Иврит",
  "Игбо",
  "Идиш",
  "Илоканский",
  "Индонезийский",
  "Ирландский",
  "Исландский",
  "Испанский",
  "Итальянский",
  "Йоруба",
  "Казахский",
  "Каннада",
  "Каталанский",
  "Кечуа",
  "Киргизский",
  "Китайский (традиционный)",
  "Китайский (упрощенный)",
  "Конкани",
  "Корейский",
  "Корсиканский",
  "Коса",
  "Креольский (гаити)",
  "Крио",
  "Курдский (курманджи)",
  "Курдский (сорани)",
  "Кхмерский",
  "Лаосский",
  "Латинский",
  "Латышский",
  "Лингала",
  "Литовский",
  "Луганда",
  "Люксембургский",
  "Майтхили",
  "Македонский",
  "Малагасийский",
  "Малайский",
  "Малаялам",
  "Мальдивский",
  "Мальтийский",
  "Маори",
  "Маратхи",
  "Мейтейлон (манипури)",
  "Мизо",
  "Монгольский",
  "Немецкий",
  "Непальский",
  "Нидерландский",
  "Норвежский",
  "Ория",
  "Оромо",
  "Панджаби",
  "Персидский",
  "Польский",
  "Португальский",
  "Пушту",
  "Руанда",
  "Румынский",
  "Русский",
  "Самоанский",
  "Санскрит",
  "Себуанский",
  "Сепеди",
  "Сербский",
  "Сесото",
  "Сингальский",
  "Синдхи",
  "Словацкий",
  "Словенский",
  "Сомалийский",
  "Суахили",
  "Сунданский",
  "Таджикский",
  "Тайский",
  "Тамильский",
  "Татарский",
  "Телугу",
  "Тигринья",
  "Тсонга",
  "Турецкий",
  "Туркменский",
  "Узбекский",
  "Уйгурский",
  "Украинский",
  "Урду",
  "Филиппинский",
  "Финский",
  "Французский",
  "Фризский",
  "Хауса",
  "Хинди",
  "Хмонг",
  "Хорватский",
  "Чви",
  "Чева",
  "Чешский",
  "Шведский",
  "Шона",
  "Шотландский (гэльский)",
  "Эве",
  "Эсперанто",
  "Эстонский",
  "Яванский",
  "Японский",
}
function capitalizeFirstWord(str)
  return str:gsub("^%l", string.upper)
end


function hasInternetConnection()
  local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
  local networkInfo = connectivityManager.getActiveNetworkInfo()
  return networkInfo ~= nil and networkInfo.isConnected()
end

if not hasInternetConnection() then
  service.asyncSpeak("Нет подключения к интернету. Невозможно перевести язык")
  return false
end

local layout = {
  GridView,
  id = "grid",
  numColumns = 1,
  layout_width = "fill",
  layout_height = "fill"
}

local dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))

dlg.setTitle("Google перевод")
.setButton2("Russian telegram", function()
  local intent = Intent(Intent.ACTION_VIEW, Uri.parse("https://t.me/addlist/ziIruC3_2WVjYWFi"))
  service.startActivity(intent)
end)
.setButton("Выход",nil)
.show()

grid.onItemClick = function(l, v)
  dlg.dismiss()
  task(500, function()
    local language = v.text
    local defaultLanguage = Locale.getDefault().getLanguage()
    local languageCode = languageCodes[language]

    if languageCode then
      local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(this.getText(node))
      url = url .. "&tl=" .. languageCode

      Http.get(url, function(status, result)
        if status == 200 then
          local translation = tostring(Html.fromHtml(result:match('<div class="result%-container">([^<]+)</div>')))
          translationResult = translationResult .. translation
          service.setText(translationResult)
          service.speak("Переводится текст:" .. translationResult)
          vibrator.vibrate(100)
         else
          print("Извините, произошла ошибка.\n Эти методы могут быть полезными:\n - Убедитесь, что вы подключены к интернету.\n - Постарайтесь обеспечить стабильное интернет-соединение.\n Примечание: Некоторые элементы, изображения, окна редактирования и т.д. могут быть не переведены.")
          vibrator.vibrate(200)
          service.playSoundTick()
        end
      end)
     else
      print("Язык не поддерживается")
      vibrator.vibrate(200)
      service.playSoundClock()
    end
  end)
end